<script>
	export let index = -1
	let resumeIndex = 0
	export let length = 0
	export let text = ''

	//defaults from https://developer.mozilla.org/en-US/docs/Web/API/SpeechSynthesisUtterance
	export let pitch = 1
	export let rate = 1
	//there's also volume
	const voices = speechSynthesis.getVoices().sort((a, b)=> a.lang.localeCompare(b.lang))
	console.log(voices)
	export let voice //XXX if voice is bound, but wouldn't auto unwrap object ?
	let debug = `debug: ${voice}`
	$: if(!voice) voice = voices.find(v=> v.lang===navigator.language)

	const utter = async text=>{
		index = resumeIndex
		return new Promise(a=>{
			const utterance = new SpeechSynthesisUtterance(text)
			utterance.voice = voice
			utterance.pitch = pitch
			utterance.rate = rate
			utterance.addEventListener('boundary', e=>{
				//name param also, is 'word' or 'sentence'
				const {charIndex, charLength} = e
				index = resumeIndex + charIndex
				length = charLength
				debug += 'boundary'
			})
			utterance.addEventListener('end', ()=>{
				debug += 'end'
				if(text.length === resumeIndex + index + length){ //actually ends
					resumeIndex = 0
					action = 'speak'
					a()
				}else{ //acts as pause
					resumeIndex = index
					action = 'resume'
				}
			})
			speechSynthesis.speak(utterance)
			debug += 'speak'
			action = 'pause'
		})
	}

	let action = 'speak'
	const actions = { //pause/resume doesn't work on android so doing it manually
		speak: ()=> utter(text.substring(resumeIndex)),
		pause: ()=>{ //speechSynthesis.pause() doesn't work because ofc imagine things working
			speechSynthesis.cancel() //calls end event
		},
		resume: ()=> utter(text.substring(resumeIndex))
	}
</script>
<style>
	#outer{
		display: flex;
		flex-flow: row wrap;
		justify-content: space-evenly;
		align-items: center;
		align-content: center;
		margin: 0.5em;
	}
	select{
		flex: 1 1 auto;
	}
	label{
		margin: 0em 0.2em;
	}
	input{
		width: 4em;
	}
</style>
<!-- only displays if browser has tts ability -->
<p>{debug}</p>
{#if voice || true}
	<div id='outer'>
		<select bind:value={voice}>
			{#each voices as voice}
				<option value={voice}>{voice.name} [{voice.lang}]</option>
			{/each}
		</select>
		<div>
			<label>
				<input type=number size=5 min=0.1 max=300 step=0.1 bind:value={pitch}/>pitch
			</label>
			<label>
				<input type=number size=5 min=0.1 max=300 step=0.1 bind:value={rate}/>rate
			</label>
		</div>
		<button disabled={!voice} on:click={()=> actions[action]()}>{action}</button>
	</div>
{/if}
